//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Client.ListDataTypeTest.ListDataTypeTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Echo String List command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStringListRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private System.Collections.Generic.List<Tecan.Sila2.StringDto> _stringList;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStringListRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="stringList">The list of string values to be returned.</param>
        public EchoStringListRequestDto(System.Collections.Generic.ICollection<string> stringList, Tecan.Sila2.IBinaryStore store)
        {
            StringList = Tecan.Sila2.DtoExtensions.Encapsulate(stringList, Tecan.Sila2.StringDto.Create, store);
        }
        
        /// <summary>
        /// The list of string values to be returned.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<Tecan.Sila2.StringDto> StringList
        {
            get
            {
                return _stringList;
            }
            set
            {
                _stringList = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/ListDataTypeTest/v1/Command/EchoStringList";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(StringList, "stringList");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(StringList, "stringList"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo String List command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStringListResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private System.Collections.Generic.List<Tecan.Sila2.StringDto> _receivedValues;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStringListResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValues">A list containing the string values that have been received.</param>
        public EchoStringListResponseDto(System.Collections.Generic.ICollection<string> receivedValues, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValues = Tecan.Sila2.DtoExtensions.Encapsulate(receivedValues, Tecan.Sila2.StringDto.Create, store);
        }
        
        /// <summary>
        /// A list containing the string values that have been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<Tecan.Sila2.StringDto> ReceivedValues
        {
            get
            {
                return _receivedValues;
            }
            set
            {
                _receivedValues = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValues, "receivedValues");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValues, "receivedValues"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Integer List command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoIntegerListRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private System.Collections.Generic.List<Tecan.Sila2.IntegerDto> _integerList;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoIntegerListRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="integerList">The list of integer values to be returned.</param>
        public EchoIntegerListRequestDto(System.Collections.Generic.ICollection<long> integerList, Tecan.Sila2.IBinaryStore store)
        {
            IntegerList = Tecan.Sila2.DtoExtensions.Encapsulate(integerList, Tecan.Sila2.IntegerDto.Create, store);
        }
        
        /// <summary>
        /// The list of integer values to be returned.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<Tecan.Sila2.IntegerDto> IntegerList
        {
            get
            {
                return _integerList;
            }
            set
            {
                _integerList = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/ListDataTypeTest/v1/Command/EchoIntegerList";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(IntegerList, "integerList");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(IntegerList, "integerList"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Integer List command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoIntegerListResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private System.Collections.Generic.List<Tecan.Sila2.IntegerDto> _receivedValues;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoIntegerListResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValues">A list containing the integer values that have been received.</param>
        public EchoIntegerListResponseDto(System.Collections.Generic.ICollection<long> receivedValues, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValues = Tecan.Sila2.DtoExtensions.Encapsulate(receivedValues, Tecan.Sila2.IntegerDto.Create, store);
        }
        
        /// <summary>
        /// A list containing the integer values that have been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<Tecan.Sila2.IntegerDto> ReceivedValues
        {
            get
            {
                return _receivedValues;
            }
            set
            {
                _receivedValues = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValues, "receivedValues");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValues, "receivedValues"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Structure List command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStructureListRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private System.Collections.Generic.List<TestStructureDto> _structureList;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStructureListRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="structureList">The list of structure values to be returned.</param>
        public EchoStructureListRequestDto(System.Collections.Generic.ICollection<TestStructure> structureList, Tecan.Sila2.IBinaryStore store)
        {
            StructureList = Tecan.Sila2.DtoExtensions.Encapsulate(structureList, TestStructureDto.Create, store);
        }
        
        /// <summary>
        /// The list of structure values to be returned.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<TestStructureDto> StructureList
        {
            get
            {
                return _structureList;
            }
            set
            {
                _structureList = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/ListDataTypeTest/v1/Command/EchoStructureList";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(StructureList, "structureList");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(StructureList, "structureList"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Structure List command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStructureListResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private System.Collections.Generic.List<TestStructureDto> _receivedValues;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStructureListResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValues">A message containing the content of all structures that have been received.</param>
        public EchoStructureListResponseDto(System.Collections.Generic.ICollection<TestStructure> receivedValues, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValues = Tecan.Sila2.DtoExtensions.Encapsulate(receivedValues, TestStructureDto.Create, store);
        }
        
        /// <summary>
        /// A message containing the content of all structures that have been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public System.Collections.Generic.List<TestStructureDto> ReceivedValues
        {
            get
            {
                return _receivedValues;
            }
            set
            {
                _receivedValues = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValues, "receivedValues");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValues, "receivedValues"));
        }
    }
    
    /// <summary>
    /// The data transfer object for Test Structure
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class TestStructureDto : Tecan.Sila2.ISilaTransferObject<TestStructure>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public TestStructureDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public TestStructureDto(TestStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        /// <summary>
        /// A value of SiLA data type String.
        /// </summary>
        public Tecan.Sila2.StringDto StringTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.StringTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.StringTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer.
        /// </summary>
        public Tecan.Sila2.IntegerDto IntegerTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.IntegerTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.IntegerTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Real.
        /// </summary>
        public Tecan.Sila2.RealDto RealTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.RealTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.RealTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Boolean.
        /// </summary>
        public Tecan.Sila2.BooleanDto BooleanTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.BooleanTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.BooleanTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Binary.
        /// </summary>
        public Tecan.Sila2.BinaryDto BinaryTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.BinaryTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.BinaryTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Date.
        /// </summary>
        public Tecan.Sila2.DateDto DateTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.DateTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.DateTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Time.
        /// </summary>
        public Tecan.Sila2.TimeDto TimeTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.TimeTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.TimeTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Timestamp.
        /// </summary>
        public Tecan.Sila2.TimestampDto TimestampTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.TimestampTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.TimestampTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Any.
        /// </summary>
        public Tecan.Sila2.DynamicClient.AnyTypeDto AnyTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.AnyTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.AnyTypeValue = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public TestStructure Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new TestStructure(StringTypeValue.Extract(store), IntegerTypeValue.Extract(store), RealTypeValue.Extract(store), BooleanTypeValue.Extract(store), BinaryTypeValue.Extract(store), DateTypeValue.Extract(store), TimeTypeValue.Extract(store), TimestampTypeValue.Extract(store), AnyTypeValue.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static TestStructureDto Create(TestStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            return new TestStructureDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((((((((("" + Argument.Require(StringTypeValue, "stringTypeValue")) 
                        + Argument.Require(IntegerTypeValue, "integerTypeValue")) 
                        + Argument.Require(RealTypeValue, "realTypeValue")) 
                        + Argument.Require(BooleanTypeValue, "booleanTypeValue")) 
                        + Argument.Require(BinaryTypeValue, "binaryTypeValue")) 
                        + Argument.Require(DateTypeValue, "dateTypeValue")) 
                        + Argument.Require(TimeTypeValue, "timeTypeValue")) 
                        + Argument.Require(TimestampTypeValue, "timestampTypeValue")) 
                        + Argument.Require(AnyTypeValue, "anyTypeValue"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _stringTypeValue;
            
            private Tecan.Sila2.IntegerDto _integerTypeValue;
            
            private Tecan.Sila2.RealDto _realTypeValue;
            
            private Tecan.Sila2.BooleanDto _booleanTypeValue;
            
            private Tecan.Sila2.BinaryDto _binaryTypeValue;
            
            private Tecan.Sila2.DateDto _dateTypeValue;
            
            private Tecan.Sila2.TimeDto _timeTypeValue;
            
            private Tecan.Sila2.TimestampDto _timestampTypeValue;
            
            private Tecan.Sila2.DynamicClient.AnyTypeDto _anyTypeValue;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(TestStructure inner, Tecan.Sila2.IBinaryStore store)
            {
                StringTypeValue = new Tecan.Sila2.StringDto(inner.StringTypeValue, store);
                IntegerTypeValue = new Tecan.Sila2.IntegerDto(inner.IntegerTypeValue, store);
                RealTypeValue = new Tecan.Sila2.RealDto(inner.RealTypeValue, store);
                BooleanTypeValue = new Tecan.Sila2.BooleanDto(inner.BooleanTypeValue, store);
                BinaryTypeValue = new Tecan.Sila2.BinaryDto(inner.BinaryTypeValue, store);
                DateTypeValue = new Tecan.Sila2.DateDto(inner.DateTypeValue, store);
                TimeTypeValue = new Tecan.Sila2.TimeDto(inner.TimeTypeValue, store);
                TimestampTypeValue = new Tecan.Sila2.TimestampDto(inner.TimestampTypeValue, store);
                AnyTypeValue = new Tecan.Sila2.DynamicClient.AnyTypeDto(inner.AnyTypeValue, store);
            }
            
            /// <summary>
            /// A value of SiLA data type String.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto StringTypeValue
            {
                get
                {
                    return _stringTypeValue;
                }
                set
                {
                    _stringTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Integer.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.IntegerDto IntegerTypeValue
            {
                get
                {
                    return _integerTypeValue;
                }
                set
                {
                    _integerTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Real.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(3)]
            public Tecan.Sila2.RealDto RealTypeValue
            {
                get
                {
                    return _realTypeValue;
                }
                set
                {
                    _realTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Boolean.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(4)]
            public Tecan.Sila2.BooleanDto BooleanTypeValue
            {
                get
                {
                    return _booleanTypeValue;
                }
                set
                {
                    _booleanTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Binary.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(5)]
            public Tecan.Sila2.BinaryDto BinaryTypeValue
            {
                get
                {
                    return _binaryTypeValue;
                }
                set
                {
                    _binaryTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Date.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(6)]
            public Tecan.Sila2.DateDto DateTypeValue
            {
                get
                {
                    return _dateTypeValue;
                }
                set
                {
                    _dateTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Time.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(7)]
            public Tecan.Sila2.TimeDto TimeTypeValue
            {
                get
                {
                    return _timeTypeValue;
                }
                set
                {
                    _timeTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Timestamp.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(8)]
            public Tecan.Sila2.TimestampDto TimestampTypeValue
            {
                get
                {
                    return _timestampTypeValue;
                }
                set
                {
                    _timestampTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Any.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(9)]
            public Tecan.Sila2.DynamicClient.AnyTypeDto AnyTypeValue
            {
                get
                {
                    return _anyTypeValue;
                }
                set
                {
                    _anyTypeValue = value;
                }
            }
        }
    }
}
